/* -----------------------------------------------------------------
 * (c) Teradyne, Inc, 2009
 * All Rights Reserved
 * Inclusion of a copyright notice does not imply that this software
 * has been published.  This software is the trade secret information
 * of Teradyne, Inc.  Use of this software is only in accordance with
 * the terms of a license agreement from Teradyne, Inc.
 * -------------------------------------------------------------------
 */

/*-------------------------------------------------------------------------------
 *  The DataGridViewComboBoxEditingControlEx provides customized method of DataGridViewComboBoxEditingControl 
 *  information for a PSet/Signal definition and the respective methods on them. 
 * ------------------------------------------------------------------------------
 */

/*
 ***************************************************************************************
 *   Revision history:
 *   Author          Date        Description of change
 *   =================================================================
 *   Subeetha            23/10/09          Created.
 ***************************************************************************************
*/

namespace Teradyne.Igxl.PSetSignalsEditor
{
    using System;
    using System.Collections.Generic;
    using System.Text;
    using System.Windows.Forms;

    /// <summary>
    /// DataGridViewComboBoxEditingControlEx override the OnSelectedIndexChanged() of DataGridViewComboBoxEditingControl
    /// </summary>
    public class DataGridViewComboBoxEditingControlEx : DataGridViewComboBoxEditingControl
    {
        /// <summary>
        /// Initializes a new instance of the DataGridViewComboBoxEditingControlEx class.
        /// </summary>
        public DataGridViewComboBoxEditingControlEx()
            : base()
        {
        }

        /// <summary>
        /// Commit the edit to raise an CellValueChanged event when SelectedIndex of 
        /// DataGridViewComboBoxEditingControl get changed.
        /// </summary>
        /// <param name="e">Type of Event Args</param>
        protected override void OnSelectedIndexChanged(EventArgs e)
        {
            base.OnSelectedIndexChanged(e);

            // Notify the CellValueChanged event.
            EditingControlDataGridView.CommitEdit(DataGridViewDataErrorContexts.Commit);
        }
    }
}
