// ------------------------------------------------------------------
// (c) Teradyne, Inc, 2006
//     All Rights Reserved
// Inclusion of a copyright notice does not imply that this software
// has been published.  This software is the trade secret information
// of Teradyne, Inc.  Use of this software is only in accordance with
// the terms of a license agreement from Teradyne, Inc.
// ------------------------------------------------------------------
// IUndoable.cs - Indicates that the impelemting component supports undo / redo
// *************************************************************************************/
//   Revision history:
//   Author         Date        Description of change
//   =================================================================
//   shoban         9/6/2007    Created
// *************************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;

namespace Teradyne.Igxl.Utilities
{
    /// <summary>
    /// Implement this interface and pass the realized object to UndoRedoManager.SaveState
    /// </summary>
    public interface IUndoable
    {
        /// <summary>
        /// Called when an undo / redo operation is requested. The state to transition
        /// to is passed as data. You need to decipher the data and update the controls
        /// to reflect the specified state
        /// </summary>
        /// <param name="undoData">The orignal data passed when SaveState was called</param>
        /// <param name="isUndoing">Indicates if the current request if for an undo or a redo</param>
        /// <returns>Should return true on success</returns>
        bool ResetState(Object undoData, bool isUndoing);
    }
}
