// ------------------------------------------------------------------
// (c) Teradyne, Inc, 2011
//     All Rights Reserved
// Inclusion of a copyright notice does not imply that this software
// has been published.  This software is the trade secret information
// of Teradyne, Inc.  Use of this software is only in accordance with
// the terms of a license agreement from Teradyne, Inc.
// ------------------------------------------------------------------
// MyServices.cs - This class is used to include the services which does not normally included
// in drop down os services in Myservices
// *************************************************************************************/
//   Revision history:
//   Author             Date        Description of change
//   =================================================================
//   Venkatachalam C    9/7/2011    Created

using System;
using System.Collections.Generic;
using System.Text;
using Teradyne.Igxl.Tools;

namespace Teradyne.Igxl.PSetSignalsEditor.PSetSignalsEditorServices
{
    /// <summary>
    /// Extend generated MyServices.
    /// </summary>
    public partial class MyServices
    {
        /// <summary>
        /// Access the Tool Manager service (which we do not want normally exposed through drop-down of services in MyServices).
        /// </summary>
        public static ToolManager ToolManager
        {
            get
            {
                return services.ToolManager;
            }
        }

        private partial class TheServices
        {
            private ToolManager _toolManager;

            public ToolManager ToolManager
            {
                get
                {
                    return ((ToolManager)(GetService(ref _toolManager)));
                }
            }

            /// <summary>
            /// Catch UpdateServices in order to add ToolManager to the subscription list or to null it
            /// This is normally done in the constructor or ApplicationQuit (respectively) but a class can only have one.
            /// </summary>
            protected override void UpdateServices()
            {
                // UpdateServices gets called when setting the svcprovider to a non-null value during startup and
                // to null during shutdown.
                // If the shutdown case, null out tool manager.
                // Note that the generated MyServices nulls out its service in ApplicationQuit but we can't have an
                // implementation of that in both partial classes.
                // We also can't rely on a Reset call because no object in this dll is in the SvcProvider framework chain
                // so Reset will never get called.
                // If the system changes and we null out Toolmanager in other cases, the worst that could happen is we
                // refetch the service in the get ToolManager property above
                if (base.SvcProvider == null)
                {
                    _toolManager = null;
                }

                // No harm in calling Add even in the null svcprovider cas
                Add(typeof(ToolManager));
                base.UpdateServices();
            }

        }
    }
}
